/**********************************************************************

This file is part of the Quantum Computation Language QCL.

(c) Copyright by Bernhard Oemer <oemer@tph.tuwien.ac.at>, 1998

This program comes without any warranty; without even the implied 
warranty of merchantability or fitness for any particular purpose.

     This program is free software under the terms of the 
     GNU General Public Licence (GPL) version 2 or higher

************************************************************************/


#ifndef DEBUG_H
#define DEBUG_H

#include "symbols.h"
#include "quheap.h"
#include "syntax.h"

#define DB_NORMAL	1
#define DB_ESCAPE	2
#define DB_ERROR	3

#define QL_ERRORREPORT	0	// report errors and continue
#define QL_ERRORABORT	1	// abort on errors
#define QL_ERRORRETURN	2	// return on errors
#define QL_IGNOREDEFERR	4	// ignore redundant defines
#define QL_IGNOREEXIT	8	// ignore exit
#define QL_NOERRMSG	16	// don't print errormessages

class objlist : public DLList<sObject*> {
public:
  objlist();
  ~objlist();
};

extern int shell_depth;

int qcllist(string fname,SymTable *loc,SymTable *gl,QuHeap *qh,sDef *def,tError *err,int flags=QL_ERRORREPORT);
int qclfile(string fname,SymTable *loc,SymTable *gl,QuHeap *qh,sDef *def,tError *err,int flags=QL_ERRORRETURN);
void qclshell(SymTable *loc,SymTable *gl,QuHeap *qh,sDef *def,tError *err,int cond);

#endif
